#include <stdlib.h>
#include "app.cc"
#include "obj_dir/Vvga.h"

int main(int argc, char **argv) {

    App* app = new App();

    // -------------------------------------
    Verilated::commandArgs(argc, argv);
    Vvga* top = new Vvga;
    // -------------------------------------

    unsigned char memory[4096];

    // Загрузить знакогенератор
    FILE* fp = fopen("font.bin", "rb");
    fread(memory + 2048, 1, 2048, fp);
    fclose(fp);

    // Заполнить чем-нибудь видеобуфер
    for (int i = 0; i < 2048; i++)
        memory[i] = i & 255;

    while (app->main()) {

        // 125k тактов 20 раз в секунду (2.5 Мгц)
        for (int i = 0; i < 125000; i++) {

            top->data = memory[ top->address ];

            top->clock = 0; top->eval();
            top->clock = 1; top->eval();

            app->vga(top->hs, top->vs, top->r*(128*65536) + top->b*(128*256) + top->g*128);
        }

        if (Verilated::gotFinish()) break;
    }

    app->destroy();
    return 0;
}
